export interface ApiConfigData {
    tokenHeader: string;
    codeHeader: string;
    appCode: string;
    appName: string;
    endpoint: string;
    authEndpoint: string;
    refreshTokenUrl: string;
    successCode: string;
    tokenExpiredCode: string;
    tokenTimeoutCode: string;
    timeout: number;
    tokenKey: string;
    tokenSession: boolean;
    attachHeaders: {
        [key: string]: string;
    };
}
export declare const apiConfig: {
    use: () => [ApiConfigData, (value: ApiConfigData | Partial<ApiConfigData>) => void];
    get: () => ApiConfigData;
    set: (value: Partial<ApiConfigData>) => void;
    subscribe(fn: () => void): () => void;
    sync(initValue: ApiConfigData, ...values: any[]): void;
};
