import React from 'react';
type containerFunc = () => HTMLElement;
type ContainerType = string | HTMLElement | containerFunc | false;
export interface ModalFactoryProp {
    open: boolean;
    getContainer: ContainerType;
}
export type ModalCloseType = () => void;
export type ModalFactory = (props: ModalFactoryProp) => React.ReactNode;
export interface UseModalProps {
    showModal(modal: React.ReactNode | ModalFactory): void;
    closeModal(): void;
    addModal(modal: React.ReactNode | ModalFactory): ModalCloseType;
    removeAll(): void;
    createModal(factory: (removeModal: ModalCloseType) => (props: ModalFactoryProp) => React.ReactNode): void;
}
declare class ModalProvider extends React.Component<any> {
    static modalIndex: number;
    static _instance: ModalProvider | undefined;
    state: {
        list: {
            open: boolean;
            modal: any;
            idx: number;
            visible: boolean;
        }[];
        isVisible: boolean;
        Modal: any;
        idx: number;
        container: React.RefObject<HTMLDivElement>;
    };
    constructor(props: any);
    setVisible: (idx: number, visible: boolean) => void;
    closeModal: () => void;
    showModal: (Modal: any) => void;
    addModal: (modal: any) => () => void;
    removeModal: (idx: number) => void;
    createModal: (factory: (removeModal: ModalCloseType) => (props: ModalFactoryProp) => React.ReactNode) => void;
    removeAll: () => void;
    render(): React.JSX.Element;
}
declare function useModal(): UseModalProps;
declare function getModal(): UseModalProps;
export { useModal, ModalProvider, getModal };
